:- unit(academic_calendar(SELF_ACADEMIC_CALENDAR)).

% item: unit parameters item
item :-
	valid_args,
	call(SELF_ACADEMIC_CALENDAR).

valid_args:-  SELF_ACADEMIC_CALENDAR = academic_calendar(_, _, _, _).

% Predicates for arguments
description(X):-
    arg(1, SELF_ACADEMIC_CALENDAR, X).

starts(X):-
	arg(2, SELF_ACADEMIC_CALENDAR, X).

ends(X):-
	arg(3, SELF_ACADEMIC_CALENDAR, X).

% Predicates of temporal units
valid_time(X):-
	arg(4, SELF_ACADEMIC_CALENDAR, X).

% DB
academic_calendar(odd_semester,  2001, 2002,  I):-
	interval(I) :> (valid_args,
	lower(L), time_point(L) :> (date(2001,10,1),time(8, 0, 0)),
	upper(U), time_point(U) :> (date(2002,2,2),time(20, 0, 0))
	).

academic_calendar(even_semester, 2001, 2002, I ):-
	interval(I) :> (valid_args,
	lower(L), time_point(L) :> (date(2002,3,4),time(8, 0, 0)),
	upper(U), time_point(U) :> (date(2002,6,22),time(20, 0, 0))
	).


academic_calendar(odd_semester,  2002, 2003,  I):-
	interval(I) :> (valid_args,
	lower(L), time_point(L) :> (date(2002,9,23),time(8, 0, 0)),
	upper(U), time_point(U) :> (date(2003,2,8),time(20, 0, 0))
	).

academic_calendar(even_semester, 2002, 2003, I ):-
	interval(I) :> (valid_args,
	lower(L), time_point(L) :> (date(2003,2,24),time(8, 0, 0)),
	upper(U), time_point(U) :> (date(2003,6,7),time(20, 0, 0))
	).
