:- unit(interval(SELF_INTERVAL)).

% Instantiates the unit arguments
item:-
	valid_args,
	lower(L), time_point(L) :> item,
	upper(U), time_point(U) :> item.

% validates unit parameters
valid_args:-
	SELF_INTERVAL = interval(L, U),
	time_point(L) :> valid_args,
	time_point(U) :> valid_args,
    	t_a(lesser_equal(L, U)) :> valid_args.

% Predicates for arguments
lower(X):-
    arg(1, SELF_INTERVAL, X).

upper(X):-
    arg(2, SELF_INTERVAL, X).
